SystemOrganization addCategory: #'Mustache-Core'!
SystemOrganization addCategory: #'Mustache-Tests'!
SystemOrganization addCategory: #'Mustache-Seaside-Core'!
SystemOrganization addCategory: #'Mustache-Seaside-Tests'!
SystemOrganization addCategory: #'Mustache-Seaside-Libs'!
SystemOrganization addCategory: #'Mustache-Seaside-Examples'!

WAExampleComponent subclass: #MustacheCounter
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:51'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter class methodsFor: 'examples' stamp: 'JesusMari 12/3/2012 11:08'!
example
	^ self new! !

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:50'!
handlerName
	^ 'examples/mustacheCounter'! !

!MustacheCounter class methodsFor: 'initialization' stamp: 'JesusMari 12/3/2012 11:08'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count
	^ count! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count: anInteger
	count := anInteger! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
decrease
	count := count - 1! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
increase
	count := count + 1! !

!MustacheCounter methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 15:37'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter methodsFor: 'rendering' stamp: 'JesusMari 2/18/2013 13:38'!
renderContentOn: html
"Server side rendered mustache"
	html mustache 
			basePath:'D:\smalltalk\SCouchViewServer\templates\';
			template:'counter';
			view: (JsonObject fromAssociations: {
						'counter'-> self count.
						'seasideContent'->[:stack : htmlCanvas|
							htmlCanvas heading: count.
							htmlCanvas anchor
								callback: [ self increase ];
								with: '++'.
							htmlCanvas space.
							htmlCanvas anchor
								callback: [ self decrease ];
								with: '--'
							]
					}).
	! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
states
	^ Array with: self! !

WAExampleComponent subclass: #MustacheCounter2
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter2 class methodsFor: 'examples' stamp: 'JesusMari 12/5/2012 16:07'!
example
	^ self new! !

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:20'!
handlerName
	^ 'examples/mustacheCounter2'! !

!MustacheCounter2 class methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count
	^ count! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count: anInteger
	count := anInteger! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
decrease
	count := count - 1! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
increase
	count := count + 1! !

!MustacheCounter2 methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter2 methodsFor: 'rendering' stamp: 'JesusMari 12/15/2012 17:22'!
renderContentOn: html

	html mustache 
			template:MustacheCounterTemplate;
			view: (JsonObject fromAssociations: {
						'counter'->self count.
						'instance'->self  .
					}).
	! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
states
	^ Array with: self! !

WAFileLibrary subclass: #JQMustacheLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Libs'!

!JQMustacheLibrary methodsFor: 'uploaded' stamp: 'JesusMari 2/8/2013 16:40'!
mustacheJs
	^ '/*!!
 * mustache.js - Logic-less {{mustache}} templates with JavaScript
 * http://github.com/janl/mustache.js
 */

/*global define: false*/

(function (root, factory) {
  if (typeof exports === "object" && exports) {
    module.exports = factory; // CommonJS
  } else if (typeof define === "function" && define.amd) {
    define(factory); // AMD
  } else {
    root.Mustache = factory; // <script>
  }
}(this, (function () {

  var exports = {};

  exports.name = "mustache.js";
  exports.version = "0.7.2";
  exports.tags = ["{{", "}}"];

  exports.Scanner = Scanner;
  exports.Context = Context;
  exports.Writer = Writer;

  var whiteRe = /\s*/;
  var spaceRe = /\s+/;
  var nonSpaceRe = /\S/;
  var eqRe = /\s*=/;
  var curlyRe = /\s*\}/;
  var tagRe = /#|\^|\/|>|\{|&|=|!!/;

  var _test = RegExp.prototype.test;
  var _toString = Object.prototype.toString;

  // Workaround for https://issues.apache.org/jira/browse/COUCHDB-577
  // See https://github.com/janl/mustache.js/issues/189
  function testRe(re, string) {
    return _test.call(re, string);
  }

  function isWhitespace(string) {
    return !!testRe(nonSpaceRe, string);
  }

  var isArray = Array.isArray || function (obj) {
    return _toString.call(obj) === ''[object Array]'';
  };

  function escapeRe(string) {
    return string.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g, "\\$&");
  }

  var entityMap = {
    "&": "&amp;",
    "<": "&lt;",
    ">": "&gt;",
    ''"'': ''&quot;'',
    "''": ''&#39;'',
    "/": ''&#x2F;''
  };

  function escapeHtml(string) {
    return String(string).replace(/[&<>"''\/]/g, function (s) {
      return entityMap[s];
    });
  }

  // Export the escaping function so that the user may override it.
  // See https://github.com/janl/mustache.js/issues/244
  exports.escape = escapeHtml;

  function Scanner(string) {
    this.string = string;
    this.tail = string;
    this.pos = 0;
  }

  /**
   * Returns `true` if the tail is empty (end of string).
   */
  Scanner.prototype.eos = function () {
    return this.tail === "";
  };

  /**
   * Tries to match the given regular expression at the current position.
   * Returns the matched text if it can match, the empty string otherwise.
   */
  Scanner.prototype.scan = function (re) {
    var match = this.tail.match(re);

    if (match && match.index === 0) {
      this.tail = this.tail.substring(match[0].length);
      this.pos += match[0].length;
      return match[0];
    }

    return "";
  };

  /**
   * Skips all text until the given regular expression can be matched. Returns
   * the skipped string, which is the entire tail if no match can be made.
   */
  Scanner.prototype.scanUntil = function (re) {
    var match, pos = this.tail.search(re);

    switch (pos) {
    case -1:
      match = this.tail;
      this.pos += this.tail.length;
      this.tail = "";
      break;
    case 0:
      match = "";
      break;
    default:
      match = this.tail.substring(0, pos);
      this.tail = this.tail.substring(pos);
      this.pos += pos;
    }

    return match;
  };

  function Context(view, parent) {
    this.view = view;
    this.parent = parent;
    this._cache = {};
  }

  Context.make = function (view) {
    return (view instanceof Context) ? view : new Context(view);
  };

  Context.prototype.push = function (view) {
    return new Context(view, this);
  };

  Context.prototype.lookup = function (name) {
    var value = this._cache[name];

    if (!!value) {
      if (name == ''.'') {
        value = this.view;
      } else {
        var context = this;

        while (context) {
          if (name.indexOf(''.'') > 0) {
            value = context.view;
            var names = name.split(''.''), i = 0;
            while (value && i < names.length) {
              value = value[names[i++]];
            }
          } else {
            value = context.view[name];
          }

          if (value !!= null) break;

          context = context.parent;
        }
      }

      this._cache[name] = value;
    }

    if (typeof value === ''function'') value = value.call(this.view);

    return value;
  };

  function Writer() {
    this.clearCache();
  }

  Writer.prototype.clearCache = function () {
    this._cache = {};
    this._partialCache = {};
  };

  Writer.prototype.compile = function (template, tags) {
    var fn = this._cache[template];

    if (!!fn) {
      var tokens = exports.parse(template, tags);
      fn = this._cache[template] = this.compileTokens(tokens, template);
    }

    return fn;
  };

  Writer.prototype.compilePartial = function (name, template, tags) {
    var fn = this.compile(template, tags);
    this._partialCache[name] = fn;
    return fn;
  };

  Writer.prototype.getPartial = function (name) {
    if (!!(name in this._partialCache) && this._loadPartial) {
      this.compilePartial(name, this._loadPartial(name));
    }

    return this._partialCache[name];
  };

  Writer.prototype.compileTokens = function (tokens, template) {
    var self = this;
    return function (view, partials) {
      if (partials) {
        if (typeof partials === ''function'') {
          self._loadPartial = partials;
        } else {
          for (var name in partials) {
            self.compilePartial(name, partials[name]);
          }
        }
      }

      return renderTokens(tokens, self, Context.make(view), template);
    };
  };

  Writer.prototype.render = function (template, view, partials) {
    return this.compile(template)(view, partials);
  };

  /**
   * Low-level function that renders the given `tokens` using the given `writer`
   * and `context`. The `template` string is only needed for templates that use
   * higher-order sections to extract the portion of the original template that
   * was contained in that section.
   */
  function renderTokens(tokens, writer, context, template) {
    var buffer = '''';

    var token, tokenValue, value;
    for (var i = 0, len = tokens.length; i < len; ++i) {
      token = tokens[i];
      tokenValue = token[1];

      switch (token[0]) {
      case ''#'':
        value = context.lookup(tokenValue);

        if (typeof value === ''object'') {
          if (isArray(value)) {
            for (var j = 0, jlen = value.length; j < jlen; ++j) {
              buffer += renderTokens(token[4], writer, context.push(value[j]), template);
            }
          } else if (value) {
            buffer += renderTokens(token[4], writer, context.push(value), template);
          }
        } else if (typeof value === ''function'') {
          var text = template == null ? null : template.slice(token[3], token[5]);
          value = value.call(context.view, text, function (template) {
            return writer.render(template, context);
          });
          if (value !!= null) buffer += value;
        } else if (value) {
          buffer += renderTokens(token[4], writer, context, template);
        }

        break;
      case ''^'':
        value = context.lookup(tokenValue);

        // Use JavaScript''s definition of falsy. Include empty arrays.
        // See https://github.com/janl/mustache.js/issues/186
        if (!!value || (isArray(value) && value.length === 0)) {
          buffer += renderTokens(token[4], writer, context, template);
        }

        break;
      case ''>'':
        value = writer.getPartial(tokenValue);
        if (typeof value === ''function'') buffer += value(context);
        break;
      case ''&'':
        value = context.lookup(tokenValue);
        if (value !!= null) buffer += value;
        break;
      case ''name'':
        value = context.lookup(tokenValue);
        if (value !!= null) buffer += exports.escape(value);
        break;
      case ''text'':
        buffer += tokenValue;
        break;
      }
    }

    return buffer;
  }

  /**
   * Forms the given array of `tokens` into a nested tree structure where
   * tokens that represent a section have two additional items: 1) an array of
   * all tokens that appear in that section and 2) the index in the original
   * template that represents the end of that section.
   */
  function nestTokens(tokens) {
    var tree = [];
    var collector = tree;
    var sections = [];

    var token;
    for (var i = 0, len = tokens.length; i < len; ++i) {
      token = tokens[i];
      switch (token[0]) {
      case ''#'':
      case ''^'':
        sections.push(token);
        collector.push(token);
        collector = token[4] = [];
        break;
      case ''/'':
        var section = sections.pop();
        section[5] = token[2];
        collector = sections.length > 0 ? sections[sections.length - 1][4] : tree;
        break;
      default:
        collector.push(token);
      }
    }

    return tree;
  }

  /**
   * Combines the values of consecutive text tokens in the given `tokens` array
   * to a single token.
   */
  function squashTokens(tokens) {
    var squashedTokens = [];

    var token, lastToken;
    for (var i = 0, len = tokens.length; i < len; ++i) {
      token = tokens[i];
      if (token) {
        if (token[0] === ''text'' && lastToken && lastToken[0] === ''text'') {
          lastToken[1] += token[1];
          lastToken[3] = token[3];
        } else {
          lastToken = token;
          squashedTokens.push(token);
        }
      }
    }

    return squashedTokens;
  }

  function escapeTags(tags) {
    return [
      new RegExp(escapeRe(tags[0]) + "\\s*"),
      new RegExp("\\s*" + escapeRe(tags[1]))
    ];
  }

  /**
   * Breaks up the given `template` string into a tree of token objects. If
   * `tags` is given here it must be an array with two string values: the
   * opening and closing tags used in the template (e.g. ["<%", "%>"]). Of
   * course, the default is to use mustaches (i.e. Mustache.tags).
   */
  exports.parse = function (template, tags) {
    template = template || '''';
    tags = tags || exports.tags;

    if (typeof tags === ''string'') tags = tags.split(spaceRe);
    if (tags.length !!== 2) throw new Error(''Invalid tags: '' + tags.join('', ''));

    var tagRes = escapeTags(tags);
    var scanner = new Scanner(template);

    var sections = [];     // Stack to hold section tokens
    var tokens = [];       // Buffer to hold the tokens
    var spaces = [];       // Indices of whitespace tokens on the current line
    var hasTag = false;    // Is there a {{tag}} on the current line?
    var nonSpace = false;  // Is there a non-space char on the current line?

    // Strips all whitespace tokens array for the current line
    // if there was a {{#tag}} on it and otherwise only space.
    function stripSpace() {
      if (hasTag && !!nonSpace) {
        while (spaces.length) {
          delete tokens[spaces.pop()];
        }
      } else {
        spaces = [];
      }

      hasTag = false;
      nonSpace = false;
    }

    var start, type, value, chr, token;
    while (!!scanner.eos()) {
      start = scanner.pos;

      // Match any text between tags.
      value = scanner.scanUntil(tagRes[0]);
      if (value) {
        for (var i = 0, len = value.length; i < len; ++i) {
          chr = value.charAt(i);

          if (isWhitespace(chr)) {
            spaces.push(tokens.length);
          } else {
            nonSpace = true;
          }

          tokens.push([''text'', chr, start, start + 1]);
          start += 1;

          // Check for whitespace on the current line.
          if (chr == ''\n'') stripSpace();
        }
      }

      // Match the opening tag.
      if (!!scanner.scan(tagRes[0])) break;
      hasTag = true;

      // Get the tag type.
      type = scanner.scan(tagRe) || ''name'';
      scanner.scan(whiteRe);

      // Get the tag value.
      if (type === ''='') {
        value = scanner.scanUntil(eqRe);
        scanner.scan(eqRe);
        scanner.scanUntil(tagRes[1]);
      } else if (type === ''{'') {
        value = scanner.scanUntil(new RegExp(''\\s*'' + escapeRe(''}'' + tags[1])));
        scanner.scan(curlyRe);
        scanner.scanUntil(tagRes[1]);
        type = ''&'';
      } else {
        value = scanner.scanUntil(tagRes[1]);
      }

      // Match the closing tag.
      if (!!scanner.scan(tagRes[1])) throw new Error(''Unclosed tag at '' + scanner.pos);

      token = [type, value, start, scanner.pos];
      tokens.push(token);

      if (type === ''#'' || type === ''^'') {
        sections.push(token);
      } else if (type === ''/'') {
        // Check section nesting.
        if (sections.length === 0) throw new Error(''Unopened section "'' + value + ''" at '' + start);
        var openSection = sections.pop();
        if (openSection[1] !!== value) throw new Error(''Unclosed section "'' + openSection[1] + ''" at '' + start);
      } else if (type === ''name'' || type === ''{'' || type === ''&'') {
        nonSpace = true;
      } else if (type === ''='') {
        // Set the tags for the next time around.
        tags = value.split(spaceRe);
        if (tags.length !!== 2) throw new Error(''Invalid tags at '' + start + '': '' + tags.join('', ''));
        tagRes = escapeTags(tags);
      }
    }

    // Make sure there are no open sections when we''re done.
    var openSection = sections.pop();
    if (openSection) throw new Error(''Unclosed section "'' + openSection[1] + ''" at '' + scanner.pos);

    tokens = squashTokens(tokens);

    return nestTokens(tokens);
  };

  // All Mustache.* functions use this writer.
  var _writer = new Writer();

  /**
   * Clears all cached templates and partials in the default writer.
   */
  exports.clearCache = function () {
    return _writer.clearCache();
  };

  /**
   * Compiles the given `template` to a reusable function using the default
   * writer.
   */
  exports.compile = function (template, tags) {
    return _writer.compile(template, tags);
  };

  /**
   * Compiles the partial with the given `name` and `template` to a reusable
   * function using the default writer.
   */
  exports.compilePartial = function (name, template, tags) {
    return _writer.compilePartial(name, template, tags);
  };

  /**
   * Compiles the given array of tokens (the output of a parse) to a reusable
   * function using the default writer.
   */
  exports.compileTokens = function (tokens, template) {
    return _writer.compileTokens(tokens, template);
  };

  /**
   * Renders the `template` with the given `view` and `partials` using the
   * default writer.
   */
  exports.render = function (template, view, partials) {
    return _writer.render(template, view, partials);
  };

  // This is here for backwards compatibility with 0.4.x.
  exports.to_html = function (template, view, partials, send) {
    var result = exports.render(template, view, partials);

    if (typeof send === "function") {
      send(result);
    } else {
      return result;
    }
  };

  return exports;

}())));

'! !

!JQMustacheLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:42'!
selectorsToInclude
	^ #(#mustacheJs)! !

WAFileLibrary subclass: #JQMustacheOnLineLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Libs'!

!JQMustacheOnLineLibrary methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 22:10'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript
		url: 'http://github.com/janl/mustache.js/raw/master/mustache.js'! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/9/2013 21:25'!
mustache: aTemplate data:theData
	"returns function call to renderize Mustache template."
	
self call:'append' with:((JSStream on:'Mustache') call:'to_html'
			 			with:(aTemplate)
						with:(JSStream on:(self render: theData)))! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/9/2013 21:21'!
mustache: aTemplate data:theData command:aString
	"returns function call to renderize Mustache template."
	
self call:aString with:((JSStream on:'Mustache') call:'to_html'
			 			with:(aTemplate)
						with:(JSStream on:(self render: theData)))! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/9/2013 21:25'!
mustache: aTemplate data:theData partials:anArrayOfPartials
	"returns function call to renderize Mustache template."

self call:'append' with:((JSStream on:'Mustache') call:'to_html'
			 	with:(aTemplate)
				with:(JSStream on:(self render: theData))
				with:(anArrayOfPartials)
				)! !

!JQueryInstance methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 2/18/2013 13:58'!
mustache: aTemplate data:theData partials:anArrayOfPartials command:anString
	"returns function call to renderize Mustache template.
	'how'' must be append after "

self call:anString with:((JSStream on:'Mustache') call:'to_html'
			 	with:(aTemplate)
				with:(JSStream on:(self render: theData))
				with:(anArrayOfPartials)
				)! !

JsonObject subclass: #Mustache
	instanceVariableNames: 'stack parser sem html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

Mustache class
	instanceVariableNames: 'cache'!

Mustache class
	instanceVariableNames: 'cache'!

!Mustache class methodsFor: 'accessing' stamp: 'JesusMari 12/8/2012 12:12'!
cache
^cache ifNil:[cache:=MustacheCache new]! !

!Mustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/21/2013 15:11'!
clearCache
cache removeAll.
cache:=nil! !

!Mustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/18/2012 09:22'!
clearComma:aTemplate
	"Replace all the $' occurrences by $'' you need this if you read a template from a file or compile a section"
	| templ |
	templ:=WriteStream on:''.
	(1 to:aTemplate size) do:[:index|
	
		((aTemplate at:index) = $')
		 	ifTrue:[templ nextPut:$';nextPut:$']
			ifFalse:[templ nextPut:(aTemplate at:index)]
	].

	^ templ contents.


! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/30/2012 10:38'!
instanceFromFolder:aFolderPath 
|instance|
instance:=self new.
instance importAllTemplatesFrom:aFolderPath relPath:''.
^instance! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/22/2012 17:05'!
render:aTemplate view:aView 
^Mustache toHtml:aTemplate view:aView
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/21/2012 22:12'!
render:aTemplate view:aView  partials:aPartialNode
^Mustache toHtml:aTemplate asString view:aView partials:aPartialNode
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 3/14/2013 19:29'!
toHtml:aTemplate 

^Mustache toHtml:aTemplate view:(Array new) partials:nil
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/30/2012 10:58'!
toHtml:aTemplate view:aView 

^Mustache toHtml:aTemplate view:aView partials:nil
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 12/9/2012 10:07'!
toHtml:aTemplate view:aView on:aHtmlCanvas
^ self toHtml:aTemplate view:aView partials:nil on:aHtmlCanvas! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 12/9/2012 10:07'!
toHtml:aTemplate view:aView partials:partialsNode
^ self toHtml:aTemplate view:aView partials:partialsNode on:nil
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 3/31/2013 13:05'!
toHtml:aTemplate view:aView partials:partialsNode on: html
| compiler tmp templ aTempl|

compiler:=self new.
compiler html:html.


(aTemplate isKindOf: MustacheTemplate class)
ifTrue:[
		aTempl:=aTemplate instance render.
		compiler partials:aTemplate partials.
	]
ifFalse:[
	partialsNode ifNil:[compiler partials]
				ifNotNil:[compiler partials: partialsNode].
	aTempl:=  aTemplate.
	].
^ compiler render: aTempl view: aView. 

! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:09'!
clearCache

self class cache removeAll.



! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 10:38'!
compile:aTemplate 
"Compiles the given ttemplate into a reusable function using the given options. In addiction to the options accepted by #parse: options: recogniced options include the folllowing:
- cache 	Set 'false' to bypass any pre-compiled version of the given template. Otherwise, a given 'template' string will be cached the first time it is parsed"
	
	^self compile:aTemplate options:JsonObject new! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/7/2013 19:25'!
compile:aTemplate options:aJsonObjOptions
"Compiles the given template into a reusable function using the given options. In addiction to the options accepted by #parse: options: recogniced options include the folllowing:
- cache 	Set 'false' to bypass any pre-compiled version of the given template. Otherwise, a given 'template' string will be cached the first time it is parsed"
	
| cblock |
self class cache manageCacheSize.
( aJsonObjOptions at:'cache' ifAbsent:[true])
ifTrue:[
	cblock:=self class cache 
				at:aTemplate 
				ifAbsent:[self rcompile:aTemplate options:aJsonObjOptions].
	cblock ifNotNil:[
		cblock outerContext receiver html: html.
		cblock outerContext receiver stack: stack.
		cblock outerContext receiver partials: self partials.
		self class cache at:aTemplate put: cblock].	.

	^cblock.	
	].
^  self rcompile:aTemplate options:aJsonObjOptions! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:19'!
escapeHTML: aString
|result table |


table:=JsonObject fromAssociations: {
	'&'-> '&amp;'.
	'<'->'&lt;'.
	'>'->'&gt;'.
	'"'->'&quot;'.
	''''->'&#39;'.
	}.

result:= aString asString copyWithRegex: '[&<>"'']+' matchesTranslatedUsing: [:ch| table at: ch].

^result! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:19'!
escapePlain: aString

^aString asString! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/9/2012 08:58'!
html
	^ html! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/3/2012 10:55'!
html: aHtmlCanvas
	html:=aHtmlCanvas! !

!Mustache methodsFor: 'instance creation' stamp: 'JesusMari 12/17/2012 10:14'!
importAllTemplatesFrom:aFolderPath relPath:relPath
| dir a elements attchPath fileName aStream instance|

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllTemplatesFrom:aFolderPath relPath:(entry name)]
			ifFalse:[	self importAllTemplatesFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		(relPath='') 
			ifFalse:[
				attchPath:=(relPath , FileDirectory pathNameDelimiter asString, fileName).
				attchPath:= attchPath copyReplaceAll: '\' with: '/'.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self partials at: attchPath put: (Mustache clearComma: aStream contents)
				]
			ifTrue:[
				attchPath:= fileName.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self  at: attchPath put: (Mustache clearComma: aStream contents)
				].
	]
]! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/27/2013 12:20'!
initialize:size 
super initialize:size.
stack:= OrderedCollection new.
parser:=MustacheParser new.



! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/21/2012 03:07'!
lookup:name stack:aStack 
"looks up the value of the given 'name' in the given context 'stack'"

^self lookup:name stack:aStack defaultValue:nil! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 13:04'!
lookup:name stack:aStack defaultValue:defaultValue
"looks up the value of the given 'name' in the given context 'stack'"
|names lastIndex target value context i j localStack|
(name = '.') ifTrue:[	^ aStack last	].
names:= name subStrings:'.'.
lastIndex:= names size.
target:= names at:lastIndex.

i:=aStack size.
localStack:=aStack copy.
j:=1.
1 to:i by: 1 do:[:pos|
	context := aStack at: pos.

	[(j < lastIndex) and:[context notNil]] whileTrue:[
		(context includesKey: (names at:j)) 
		ifTrue:[
			context:=(context at: (names at:j)).
			localStack add:context.
			j:= j + 1.
			]
		ifFalse:[
			localStack remove:context.
			context:=nil.
			]
		].	
	
	context ifNotNil:[
		((context isKindOf: JsonObject) and:[ context includesKey: target]) ifTrue:[
			value:= context at:target.
			(value isKindOf: BlockClosure) ifTrue:[
				value:= value valueWithEnoughArguments: (Array with: localStack last with:html)].
			value ifNil:[^defaultValue].
			(value isKindOf:WAObject) ifTrue:[value:=''].
			^value.
		]
	]
].
(value isKindOf: BlockClosure) ifTrue:[
	value:= value valueWithEnoughArguments: (Array with: localStack last with:html)].
value ifNil:[^defaultValue].
^value.! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/23/2012 19:44'!
parser
	^ parser! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/23/2012 19:44'!
parser: anObject
	parser := anObject! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 9/30/2012 10:46'!
partials
^ self at:'partials' ifAbsent:[self at:'partials' put: JsonObject new].
	! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 9/27/2012 18:01'!
partials: anObject
	self at:'partials' put:anObject! !

!Mustache methodsFor: 'private' stamp: 'JesusMari 12/20/2012 05:06'!
rcompile:aTemplate options:options

| body context compiledBlock  | 
body:= parser parse: aTemplate options: options.

[
	compiledBlock:= (Compiler evaluate:body contents for: self logged:false ).
	compiledBlock ifNil:[self error:'Compilation Error']
]on:Error
do:[:err|
	|mes|
	 mes:=(err description, String crlf),
		(err messageText , String crlf),
		(err location asString , String crlf),
		(aTemplate truncateTo: 80), String crlf,
		((body contents) copyFrom:1 to: (err location)), '^^^^',
		((body contents) copyFrom: err location to: (body contents size)),
		String crlf.
		Transcript show: mes.
		html ifNotNil:[self renderErrorToSeaside:mes].
		^ [mes]
	].
		
^ compiledBlock ! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 10:44'!
render: aTemplate view:aView 
"High-level function that renders the given 'template' using the given 'view' and 'partials'. If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "
^self render:aTemplate view:aView partials:self partials! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/7/2013 19:25'!
render: aTemplate view:aView partials:partialsTemp
"High-level function that renders the given 'template' using the given 'view' and 'partials'. If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "
| cm str|

(aView isKindOf:OrderedCollection ) 
	ifTrue:[self stack:aView]
	ifFalse:[self stack: (OrderedCollection with:aView)].
self partials:partialsTemp.
cm:= self compile:aTemplate.
[
str:=html ifNil:[(cm valueWithEnoughArguments: (Array with:aView with:self partials)) contents]
		ifNotNil:[cm valueWithEnoughArguments: (Array with:aView with:self partials)].
] on:Error do:[:err|
	|mes|
	 mes:=(err description, String crlf),
		(err messageText , String crlf),
		String crlf.
		Transcript show: mes.
		html ifNotNil:[self renderErrorToSeaside: mes]
].		
str ifNil:[str:=''].
^str! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:20'!
renderErrorToSeaside:amesg
html preformatted: amesg! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/21/2012 02:59'!
renderSection:name view: aStack callback: callback
^ self renderSection:name view: aStack callback: callback inverted:false.
! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 10:52'!
renderSection:name view: aStack callback: callback inverted:inverted

| buffer value scopeRender callbackResult block|
buffer:= ReadWriteStream on:''.
value:= self lookup: name stack: aStack.
callbackResult:=callback value.
"a bit of magic..."

inverted 
ifTrue: [
	"From the spec: inverted sections may render text once based on the inverse value of the key. That is, they will be rendered if the key doesn't exist, is false, or is an empty list"
	value ifNil:[buffer nextPutAll: (callback value )	].
	((value isKindOf:Boolean) and:[value not]) ifTrue:[buffer nextPutAll: (
		Mustache toHtml:callbackResult view:stack last partials:self partials on:html )	].		
	((value isKindOf:Array) and:[value isEmpty]) ifTrue:[buffer nextPutAll: (
		Mustache toHtml:callbackResult view:stack last partials:self partials on:html) 	].	
	]
ifFalse:[
	(value isKindOf:Array)
	ifTrue:[
		value do:[:val|
			stack add:val.
			buffer nextPutAll:  (Mustache 	toHtml:callbackResult 
											view: stack 
											partials:self partials
											on:html).
			stack remove:val.
			]
		]
	ifFalse:[
		(value isKindOf:JsonObject)
		ifTrue:[
			stack add:value.
			buffer nextPutAll:  (Mustache 	toHtml:callbackResult 
											view:stack first
											partials:self partials
											on:html).
			stack remove:value.
			]
		ifFalse:[
			(value isKindOf:BlockClosure)
			ifTrue:[
				block:=Compiler evaluate:value for: self logged: false.
				buffer nextPutAll: (
					Mustache 	toHtml: (block valueWithEnoughArguments: (
									Array with: (callback value )
										   with: stack last) ) 
								view:stack last 
								partials:self partials
								on:html).
				]
			ifFalse:[
				(value notNil and:[(value isKindOf:Boolean) ifTrue:[value] ifFalse:[true]]) ifTrue: [
					buffer nextPutAll: (
					Mustache
					 toHtml:callbackResult view:stack last partials:self partials on:html)].
				]
			] 
		
		]
	].
^buffer contents! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 10:53'!
renderTemplateAt: aTemplate view:aView 
"High-level function that renders the given 'template' located in the partials node, using the given 'view'  If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "


^ self render: (self class clearComma:(self at:aTemplate)) view:aView.
! !

!Mustache methodsFor: '*mustache-seaside' stamp: 'JesusMari 12/8/2012 08:31'!
renderTemplateAt: aTemplate view:aView on:htmlCanvas
"High-level function that renders the given 'template' located in the partials node, using the given 'view'  If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "

self html:htmlCanvas.
^ self render: (self class clearComma:(self at:aTemplate)) view:aView.! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:40'!
stack
	^ stack! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:40'!
stack: anObject
	stack := anObject! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/19/2012 02:34'!
tags
	parser tags! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/19/2012 02:35'!
tags: twoTags
	parser tags:twoTags! !

JsonObject subclass: #MustacheTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

MustacheTemplate class
	instanceVariableNames: 'instance'!

MustacheTemplate class
	instanceVariableNames: 'instance'!

MustacheTemplate subclass: #MuSTemplate
	instanceVariableNames: 'fullDocument builder document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!MuSTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/8/2013 19:15'!
instance
|sub|
super initialize.
instance:=self new.
self subclasses do:[:aSubClass|
	instance addPartial: (aSubClass instance 
							fullDocument:false;
							setScriptGenerator:instance getScriptGenerator;
							yourself).
].
instance initialize.
^instance! !

!MuSTemplate methodsFor: 'accessing' stamp: 'JesusMari 2/22/2013 11:13'!
fullDocument
	^ fullDocument! !

!MuSTemplate methodsFor: 'accessing' stamp: 'JesusMari 2/22/2013 11:13'!
fullDocument: anObject
	fullDocument := anObject! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:22'!
getHtmlBuilder
builder ifNil:[^ builder:=WAHtmlCanvas builder] ifNotNil:[^builder].
 ! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:23'!
getHtmlDocument
document ifNil:[^ document:=self getHtmlBuilder documentClass new] ifNotNil:[^document].
 ! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 19:14'!
getScriptGenerator
^ self getHtmlDocument scriptGenerator.
 ! !

!MuSTemplate methodsFor: 'initialize-release' stamp: 'JesusMari 2/22/2013 11:14'!
initialize
fullDocument := false.! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 19:29'!
render
"return the renderized html content included in renderContentOn:"
|  result  htmlRoot|

builder:=self getHtmlBuilder.
document:= self getHtmlDocument.
self fullDocument ifTrue:[htmlRoot:=builder rootClass new].
self fullDocument ifTrue:[self updateRoot:htmlRoot].
self fullDocument ifTrue:[htmlRoot writeHeadOn: document].
WACurrentRequestContext 
		use: self requestContext
		during: [
			 document nextPutAll:  (builder render: [:h | self renderContentOn:h]). ].

self fullDocument ifTrue:[htmlRoot writeFootOn: document].
^ document stream contents

! !

!MuSTemplate methodsFor: 'abstract' stamp: 'JesusMari 2/20/2013 20:12'!
renderContentOn:html
self subclassResponsibility! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 2/28/2013 03:45'!
requestContext

^WARequestContext  
		request: WARequest new
		response: WAResponse new
		codec: GRNullCodec new! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:24'!
setHtmlBuilder:aBuilder
builder:=aBuilder! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 13:25'!
setHtmlDocument:aDoc
document:=aDoc! !

!MuSTemplate methodsFor: 'private' stamp: 'JesusMari 3/8/2013 19:28'!
setScriptGenerator:aScriptGenerator

^ self getHtmlDocument scriptGenerator:aScriptGenerator.
 ! !

!MuSTemplate methodsFor: 'abstract' stamp: 'JesusMari 2/22/2013 10:45'!
updateRoot:anHtmlRoot
"everwrite this method to include headers"
! !

MuSTemplate subclass: #MuSTest0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest0 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 20:01'!
renderContentOn:html
html paragraph:(html mustache variable:#name)! !

MuSTemplate subclass: #MuSTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/21/2013 15:32'!
renderContentOn:html
html heading:'Simple test'.
html paragraph:('Hello ' , (html mustache variable:'name')).
html paragraph:('you work as a ' , (html mustache variable:'profession'))
! !

MuSTemplate subclass: #MuSTest11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest11 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 20:05'!
renderContentOn:html
html heading:'Simple test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html paragraph:('your salary is ' , (html mustache variable:#solory))
! !

MuSTemplate subclass: #MuSTest12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest12 methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 09:59'!
renderContentOn:html
html heading:'Calculation test'.
html paragraph:('Hello ' , (html mustache variable:'name')).
html paragraph:('you work as a ' , (html mustache variable:'profession')).
html paragraph:('your salary is ' , (html mustache variable:'calculation')).
! !

MuSTemplate subclass: #MuSTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest2 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:26'!
renderContentOn:html
html heading:'Section test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html paragraph:'your latest jobs: '.
html unorderedList: [
	html mustache section name:#experience;with:[
			html listItem:( html mustache variable:#job)].
	html mustache section name:#experience;inverted;with:[
			html listItem:'no items']
	]! !

MuSTemplate subclass: #MuSTest21
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest21 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:25'!
renderContentOn:html
html heading:'Empty Section test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html paragraph:'your latest jobs: '.
html unorderedList: [
	html mustache section name:#nonexistingsection;with:[
			html listItem:( html mustache variable:#job)].
	html mustache section name:#nonexistingsection;inverted;with:[
			html listItem:'no items']
	]! !

MuSTemplate subclass: #MuSTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:49'!
renderContentOn:html
html heading:'Simple test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html script:(html mustache unescapedVariable:#profession)
! !

MuSTemplate subclass: #MuSTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest4 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:55'!
renderContentOn:html
html heading:'outer context test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html mustache section name:#experience;with:[
html paragraph:( (html mustache variable:#name),'-->',(html mustache variable:#job)).
	]

! !

MuSTemplate subclass: #MuSTest41
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest41 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:57'!
renderContentOn:html
html heading:'outer context test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html mustache section name:#experience;with:[
html paragraph:( (html mustache variable:'experience.name'),'-->',(html mustache variable:#job)).
	]

! !

MuSTemplate subclass: #MuSTest5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

MuSTest5 subclass: #MuSPartial1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSPartial1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 09:53'!
renderContentOn:html
html unorderedList: [
	html mustache section name:#experience;with:[
			html listItem:( html mustache variable:#job)].
	html mustache section name:#experience;inverted;with:[
			html listItem:'no items']
	]! !

!MuSTest5 methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 09:51'!
renderContentOn:html
html heading:'Partials test'.
html paragraph:('Hello ' , (html mustache variable:#name)).
html paragraph:'your latest jobs: '.
html mustache partial:#MuSPartial1! !

MuSTemplate subclass: #MuSTest6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest6 methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 10:35'!
renderContentOn:html
html heading:'Client side test'.
html paragraph:('Hello ' , (html mustache variable:'name')).

"Client side template"
html mustache template:#clientTemplate;with:[
	html unorderedList:[
		html mustache section name:#experience;with:[
			html listItem: [html mustache variable:#job ]]
		]
	].
! !

MustacheTemplate subclass: #MustacheCounterTemplate
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!MustacheCounterTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:22'!
render
^'<h1>Mustache Counter:{{counter}}</h1>

<p>Hello "Seaside code" passed through a View to Mustache </p>

{{[
	html paragraph:''Hello again from seaside inside a square bracket''.
	html paragraph:aView asString.
	html anchor
			callback:[aView instance increase];
			with: ''++''.
			
	html space.
	html anchor
			callback:[aView instance decrease];
			with: ''--''.							
]}}

{{>Partial3}}'! !

MustacheCounterTemplate subclass: #Partial3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!Partial3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:06'!
render

^'{{[ 
		html heading: (aView at:''counter'').
	]}}'! !

!MustacheTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/30/2012 13:40'!
instance
|sub|
super initialize.
instance:=self new.
self subclasses do:[:aSubClass|
	instance addPartial: aSubClass instance.
].
instance initialize.
^instance! !

!MustacheTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/7/2013 12:40'!
partials
"must be instance not call self instance again"
instance ifNil:[self instance].
^ instance partials! !

!MustacheTemplate methodsFor: 'private' stamp: 'JesusMari 6/18/2012 20:13'!
addPartial:aMustachePartial

| p |
p:=self at:'partials' ifAbsent:[self at:'partials' put: JsonObject new].
p at:(aMustachePartial class asString) put:(aMustachePartial render)
! !

!MustacheTemplate methodsFor: 'abstract' stamp: 'JesusMari 6/15/2012 12:32'!
render
	"return an Template within a string"
self subclassResponsibility ! !

MustacheTemplate subclass: #MustacheTest0
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest0 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:58'!
render
^'{{name}}'! !

MustacheTemplate subclass: #MustacheTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 11:48'!
render
	"return an Template within a string"

^'Simple test

Hello {{name}}
you work as {{profession}}'! !

MustacheTemplate subclass: #MustacheTest11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest11 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 13:06'!
render
	"return an Template within a string"

^'Simple test

Hello {{name}}
you work as {{profession}}
Your salary is ${{solory}}!!'! !

MustacheTemplate subclass: #MustacheTest12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest12 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:16'!
render
	"return an Template within a string"

^'Calculation test

Hello {{name}}
you work as {{profession}}
Your salary is ${{calculation}}!!'! !

MustacheTemplate subclass: #MustacheTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest2 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 11:50'!
render
	"return an Template within a string"

^'Section test
Hello {{name}}
you work as {{profession}}
{{#experience}}*{{job}};{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest21
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest21 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:41'!
render
	"return an Template within a string"

^'Empty Section test
Hello {{name}}
you work as a {{profession}}
{{#expe}}*{{job}};{{/expe}}
{{^expe}}Ops!!{{/expe}}
'! !

MustacheTemplate subclass: #MustacheTest22
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest22 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:13'!
render
	"return an Template within a string"

^'Wrapped Section test
Hello {{name}}
you work as a {{profession}}
{{#wrapped}}{{#experience}}{{job}},{{/experience}}{{/wrapped}}'! !

MustacheTemplate subclass: #MustacheTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:15'!
render
	"return an Template within a string"

^'Escaped/non escaped test

*{{name}}
*{{profession}}
*{{company}}
*{{{company}}}
'! !

MustacheTemplate subclass: #MustacheTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest4 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/27/2013 11:07'!
render
	"return an Template within a string"

^'Non Empty List test outer content access

{{name}}
{{#experience}}
{{name}}--->{{job}}
{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest41
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest41 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/27/2013 12:18'!
render
	"return an Template within a string"

^'Non Empty List test outer content access

{{name}}
{{#experience}}
{{experience.name}}--->{{job}}
{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest5 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:30'!
render
	"return an Template within a string"

^'Partials Test

Hello {{name}}
you work as a {{profession}}
{{>Partial1}}
Salary:
{{#wrapped}}
{{>Partial2}}
{{/wrapped}}
'! !

MustacheTest5 subclass: #Partial1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!Partial1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:29'!
render
^'{{#experience}}{{job}},{{/experience}}'! !

MustacheTest5 subclass: #Partial2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!Partial2 methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:30'!
render
^'{{#experience}}{{job}},{{/experience}}'! !

MustacheTemplate subclass: #MustacheTest6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest6 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:18'!
render
	"return an Template within a string"

^'Set Delimiters Test

* {{default_tags}}
{{=<% %>=}}
* <% erb_style_tags %>
<%={{ }}=%>
*{{default_tags_again}}
'! !

Dictionary subclass: #MustacheCache
	instanceVariableNames: 'monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

!MustacheCache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 11/7/2012 11:37'!
cacheSize
"Cache size> when the size is grater than xxx deletes a half of the cached templates"
^50! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 15:26'!
at: sourceCode
	
	| a |
	monitor critical: [
		a:=super at:sourceCode.
		monitor signal
		].
	^a
	! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 15:26'!
at: sourceCode ifAbsent:aBlock
	
	| a |
	monitor critical: [
		a:=super at:sourceCode ifAbsent:aBlock.
		monitor signal
		].
	^a
	! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 15:26'!
at: sourceCode put:aCompiledSourceCode
	
	| a |
	 monitor critical: [
		a:=super at:sourceCode put:aCompiledSourceCode.
		monitor signal
		].
	^a
	! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 15:26'!
initialize:size
super initialize:size.
monitor:=Monitor new! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 15:26'!
manageCacheSize
"removes the elements from 1 to cacheSize/2 if the size is greater than #cacheSize "
monitor critical:[
(super size > self class cacheSize) ifTrue:[
	super keys do:[:aKey|
		super removeKey: aKey.
		(super size < ((self class cacheSize / 2 ))) ifTrue:[
			monitor signal.
			 ^self].
		]
	].
].

^ self! !

!MustacheCache methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/20/2013 15:26'!
removeAll

      monitor critical: [
		super removeAll.
	[monitor signal] on:Error do:[self]  
      ].
 	


! !

TestCase subclass: #MuSTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Tests'!

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 19:49'!
getStash
| a b c |
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
a name:'Jesus Mar'.
a profession:'engineer'.
a company:'<b>Tirme</b>'.
a salary: 3000.
a calculation:[ :stash| (stash salary * 0.9) asString , ' Euros']. 
b job:'Electrician'.
b name:'caco'.
c job:'Singer'.
c name:'coca'.
a experience: (Array with:b with:c).
a wrapped:  [[:v :s| |mesg calc inner|
               "get the content"
               inner:= Mustache render: v asString view:s partials:self partials.
               mesg:='salary 13% of ', s salary asString,':'.
               calc := ((s salary )- ((s salary) * 13 / 100)) asFloat .
               mesg:=mesg , calc asString, ' Euros, working as ', inner.
               ]]. 
^a! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 11:49'!
testClientSide

self assert:((MuSTest6 instance render) = '<h1>Client side test</h1><p>Hello {{name}}</p><script id="clientTemplate" type="text/x-jquery-tmpl"><ul>{{#experience}}<li></li>{{/experience}}</ul></script>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:23'!
testEmptySection

self assert:  ((Mustache toHtml:MuSTest21 view:self getStash) = '<h1>Empty Section test</h1><p>Hello Jesus Mar</p><p>your latest jobs: </p><ul><li>no items</li></ul>') .! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 19:59'!
testEmptyTemplate
self assert:((Mustache toHtml:MuSTest0 view:self getStash) = '<p>Jesus Mar</p>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 20:06'!
testEmptyVariable

self assert:((Mustache toHtml:MuSTest11 view:self getStash) = '<h1>Simple test</h1><p>Hello Jesus Mar</p><p>your salary is </p>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:56'!
testOuterContext

self assert:((Mustache toHtml:MuSTest4 view:self getStash) = '<h1>outer context test</h1><p>Hello Jesus Mar</p><p>Jesus Mar--&gt;Electrician</p><p>Jesus Mar--&gt;Singer</p>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:58'!
testOuterContextSameVariableInnerContext

self assert:((Mustache toHtml:MuSTest41 view:self getStash) = '<h1>outer context test</h1><p>Hello Jesus Mar</p><p>caco--&gt;Electrician</p><p>coca--&gt;Singer</p>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 09:54'!
testPartials

self assert:((Mustache toHtml:MuSTest5 view:self getStash) = '<h1>Partials test</h1><p>Hello Jesus Mar</p><p>your latest jobs: </p><ul><li>Electrician</li><li>Singer</li></ul>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:26'!
testSection

self assert:((Mustache toHtml:MuSTest2 view:self getStash) = '<h1>Section test</h1><p>Hello Jesus Mar</p><p>your latest jobs: </p><ul><li>Electrician</li><li>Singer</li></ul>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 22:00'!
testVariable

self assert:((Mustache toHtml:MuSTest1 view:self getStash) = '<h1>Simple test</h1><p>Hello Jesus Mar</p><p>you work as a engineer</p>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2013 09:57'!
testVariableCalculation

self assert:((Mustache toHtml:MuSTest12 view:self getStash) ='<h1>Calculation test</h1><p>Hello Jesus Mar</p><p>you work as a engineer</p><p>your salary is 2700.0 Euros</p>')! !

!MuSTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 21:50'!
testVariableEscapedNonEscape

self assert:((Mustache toHtml:MuSTest3 view:self getStash) = '<h1>Simple test</h1><p>Hello Jesus Mar</p><script type="text/javascript">/*<!![CDATA[*/engineer/*]]>*/</script>')! !

TestCase subclass: #MustacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Tests'!

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 13:03'!
getStash
| a b c |
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
a name:'Jesus Mar'.
a profession:'engineer'.
a company:'<b>Tirme</b>'.
a salary: 3000.
a calculation:[ :stash| (stash salary * 0.9) asString , ' Euros']. 
b job:'Electrician'.
b name:'caco'.
c job:'Singer'.
c name:'coca'.
a experience: (Array with:b with:c).
a wrapped:  [[:v :s| |mesg calc inner|
               "get the content"
               inner:= Mustache render: v asString view:s partials:self partials.
               mesg:='salary 13% of ', s salary asString,':'.
               calc := ((s salary )- ((s salary) * 13 / 100)) asFloat .
               mesg:=mesg , calc asString, ' Euros, working as ', inner.
               ]]. 
^a! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/27/2013 14:45'!
testEmptySection

self assert:  ((Mustache toHtml:MustacheTest21 view:self getStash) = 'Empty Section test
Hello Jesus Mar
you work as a engineer
Ops!!
') .! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:00'!
testEmptyTemplate
self assert:((Mustache toHtml:MustacheTest0 view:self getStash) = 'Jesus Mar')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 11:49'!
testEmptyVariable

self assert:((Mustache toHtml:MustacheTest11 view:self getStash) = 'Simple test

Hello Jesus Mar
you work as engineer
Your salary is $!!')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:46'!
testOuterContext

self assert:((Mustache toHtml:MustacheTest4 view:self getStash) = 'Non Empty List test outer content access

Jesus Mar
Jesus Mar--->Electrician
Jesus Mar--->Singer

')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/27/2013 14:44'!
testOuterContextSameVariableInnerContext

self assert:((Mustache toHtml:MustacheTest41 view:self getStash) = 'Non Empty List test outer content access

Jesus Mar
caco--->Electrician
coca--->Singer

')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 13:05'!
testPartials

self assert:((Mustache toHtml:MustacheTest5 view:self getStash) = 'Partials Test

Hello Jesus Mar
you work as a engineer
Electrician,Singer,
Salary:
salary 13% of 3000:2610.0 Euros, working as Electrician,Singer,

')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 11:49'!
testSection

self assert:((Mustache toHtml:MustacheTest2 view:self getStash) = 'Section test
Hello Jesus Mar
you work as engineer
*Electrician;*Singer;
')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:27'!
testSetSelimiters

self assert:((Mustache toHtml:MustacheTest6 ) = 'Set Delimiters Test

* 

* 

*
')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 11:49'!
testVariable

self assert:((Mustache toHtml:MustacheTest1 view:self getStash) = 'Simple test

Hello Jesus Mar
you work as engineer')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:17'!
testVariableCalculation

self assert:((Mustache toHtml:MustacheTest12 view:self getStash) ='Calculation test

Hello Jesus Mar
you work as engineer
Your salary is $2700.0 Euros!!')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 20:04'!
testVariableEscapedNonEscape

self assert:((Mustache toHtml:MustacheTest3 view:self getStash) = 'Escaped/non escaped test

*Jesus Mar
*engineer
*&lt;b&gt;Tirme&lt;/b&gt;
*<b>Tirme</b>
')! !

!MustacheTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2013 12:14'!
testWrappedSection

self assert:((Mustache toHtml:MustacheTest22 view:self getStash) = 'Wrapped Section test
Hello Jesus Mar
you work as a engineer
salary 13% of 3000:2610.0 Euros, working as Electrician,Singer,').! !

Object subclass: #MustacheParser
	instanceVariableNames: 'name version tags view partials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:00'!
debug: aMessage template: aTemplate line: lineNumber file: fileName
|horror|
horror:= 
	aMessage,' in ', 
	(aTemplate copyFrom:1 to: lineNumber),
	'(^v^)' , 
	(aTemplate copyFrom:lineNumber to:aTemplate size),
	String crlf ,
	'Char:', lineNumber asString, 
	String crlf. 
Transcript show: horror.
^horror! !

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 11:07'!
initialize 
super initialize.
name:='mustache'.
version:= '0.5.0-dev'.
tags:= Array with:'{{' with:'}}'.

! !

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/23/2012 19:38'!
messageSelectorAndArgumentNames
| stack |
[:aView :aPartials|
		|buffer line|
	 	buffer:= ReadWriteStream on:''.
	 	line:=1.
	 	buffer nextPutAll:'*'.
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'nombre' stack:stack defaultValue: (String new))).
buffer nextPutAll:'*'
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
buffer nextPutAll:'
*'
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'empresa' stack:stack defaultValue: (String new))).
buffer nextPutAll:'
*'
.

line:=1.
		buffer nextPutAll: (self lookup:'empresa' stack:stack defaultValue: (String new)).
	buffer nextPutAll:'
'
.

line:=1.
		[ |nameexperiencia callbackexperiencia|
		nameexperiencia:='experiencia'.
		callbackexperiencia:=[ 
			|bufferexperiencia|
			bufferexperiencia:=ReadWriteStream on:''.
			bufferexperiencia nextPutAll:'--'
.

line:=1.
		bufferexperiencia nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
bufferexperiencia nextPutAll:'
'
.
bufferexperiencia contents].

	buffer nextPutAll: (self renderSection:nameexperiencia view:stack callback:callbackexperiencia).
			buffer contents.
			] value.
	buffer nextPutAll:'
'
.

line:=1.
		[ |nametasas callbacktasas|
		nametasas:='tasas'.
		callbacktasas:=[ 
			|buffertasas|
			buffertasas:=ReadWriteStream on:''.
			buffertasas nextPutAll:''.

line:=1.
		buffertasas nextPutAll: (self escapeHTML:(self lookup:'paga' stack:stack defaultValue: (String new))).
buffertasas nextPutAll:' por '
.

line:=1.
		buffertasas nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
buffertasas nextPutAll:'
'
.
buffertasas contents].

	buffer nextPutAll: (self renderSection:nametasas view:stack callback:callbacktasas).
			buffer contents.
			] value.
	buffer nextPutAll:''.
	buffer contents].! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:42'!
name
	^ name! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
name: anObject
	name := anObject! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 5/19/2012 00:21'!
parse: aTemplate 
"Parses the given 'template' and returns the source of a function that, with the proper arguments, will render the template. Recognized options include the following:
- file The name of the file the template comes from (displayed in error message)
- tags An Array of open and close tags the template uses. Defaults to the value of Mustache tags instance variable.
- debug Set 'true' to log the body of the generated function to the console.
- space Set 'true' to preserve whitespaces from lines that otherwise contain only a {{tag}}. Default to 'false' "

self parse: aTemplate options:(JsonObject new)! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 3/7/2013 11:10'!
parse: aTemplate options:aJsonObjOptions
"Parses the given 'template' and returns the source of a function that, with the proper arguments, will render the template. Recognized options include the following:
- file The name of the file the template comes from (displayed in error message)
- tags An Array of open and close tags the template uses. Defaults to the value of Mustache tags instance variable.
- debug Set 'true' to log the body of the generated function to the console.
- space Set 'true' to preserve whitespaces from lines that otherwise contain only a {{tag}}. Default to 'false' "

|myTags code openTag closeTag spaces hasTag nonSpace streapSpace sectionStack updateLine nextOpenTag nextCloseTag setTags includePartial openSection line  openInvertedSection closeSection sendPlain sendEscaped codeInject c callback i end sourceCode lastI |

myTags:=aJsonObjOptions at:'tags' ifAbsent:[self tags].
openTag:=myTags at:1.
closeTag:=myTags at:2.
code:= ReadWriteStream on:''.
sectionStack:=Stack new.
code  
		nextPutAll: 	'[:aView :aPartials|
		|buffer line|
		
		html ifNil:[buffer:= ReadWriteStream on:',$' asString,$' asString,']
			 		ifNotNil:[buffer:= html document].
	 	line:=0.
	 	buffer nextPutAll:';nextPut:$'.

	
spaces:=Stack new.   "Indices of whitespace in code on the current line"
hasTag:= false.      "Is there a {{tag}} on the current line"	
nonSpace:= false.      "Is there a non-space char on the current line"

streapSpace:=[
	(hasTag and:[nonSpace not and:[(aJsonObjOptions at:'space' ifAbsent:[false]) not]])	
	ifTrue:[
		"???? TODO"
		]
	].

setTags:=[:source :bool :aName|
	|section|
	myTags:= source trimSpaces subStrings: (Character space asString).
	nextOpenTag:= myTags at:1.
	nextCloseTag:=myTags at:2.		
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code nextPutAll: '.
		buffer',section ,' nextPutAll:';nextPut:$'.
	 ].

includePartial:=[:source :bool :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll:'[|partial|
			partial:= self partials at:';
		nextPut: $';
		nextPutAll: source trimSpaces;
		nextPut: $';
		nextPutAll:' ifAbsent:[nil].
		partial ifNotNil:[ buffer', section  ,' nextPutAll: (self render:partial view: (stack) partials:self partials)]] value.';crlf;
		nextPutAll:'buffer', section  ,' nextPutAll:';nextPut:$'.
	].

openSection:=[:source :inverted |
	|aName|
	aName:= source trimSpaces.
	(aName = '') ifTrue: [self debug:'Section name may not be empty' template:aTemplate line:line file:(aJsonObjOptions at:'file')].
	
	sectionStack push: (JsonObject fromAssociations: {'name'-> aName. 'inverted'->inverted}).
	code  nextPutAll: '.';crlf;
		nextPutAll:  updateLine;
		nextPutAll: '
		[ |name',aName ,' callback',aName ,'|
		name',aName ,':=';
		nextPut: $';
		nextPutAll: aName; 
		nextPut: $';
		nextPut: $.;
		nextPutAll:'
		callback',aName ,':='; nextPut:$'.
].

openInvertedSection:= 	[:source|
	openSection value:source value:true.		
	] .

closeSection:=[:source |
	|aName section openName|
	aName:= source trimSpaces.
	openName:=nil.
	(sectionStack size > 0) 
	ifTrue:[
		openName:=sectionStack pop. 
	].

	(openName name isNil or:[(aName = openName name) not]) 
	ifTrue: [
		self error: (self debug:'Section name may not be empty' template:aTemplate line:line file:(aJsonObjOptions at:'file'))
		].
	section:=openName.
	code  nextPutAll: '.';crlf.

	(section at:'inverted' ifAbsent:[false]) 
	ifTrue:[
		code crlf;nextPutAll:'	buffer nextPutAll: (self renderSection:name',aName ,' view:stack callback:callback',aName ,' inverted:true).
			buffer contents.
		] value.'.
		]
	ifFalse:[
		code crlf;nextPutAll:'	buffer nextPutAll: (self renderSection:name',aName ,' view:stack callback:callback',aName ,').
			buffer contents.
			] value.'.
		].
	code crlf;
	nextPutAll:'	buffer nextPutAll:';nextPut:$'.

].

sendPlain:=[:source :bool :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll:  updateLine;
		nextPutAll: '
		buffer',section ,' nextPutAll: (self lookup:';
		nextPut:$';
		nextPutAll: source trimSpaces ;
		nextPut:$';
		nextPutAll:' stack:stack defaultValue: (String new)).';
		crlf;
		nextPutAll:'	buffer',section ,' nextPutAll:';nextPut:$'.
	].

sendEscaped:=[:source :bool  :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll: '
		buffer',section ,' nextPutAll: (self escapeHTML:(self lookup:';
		nextPut:$';
		nextPutAll: source trimSpaces ;
		nextPut:$';
		nextPutAll:' stack:stack defaultValue: (String new))).';
		crlf;
		nextPutAll:'buffer',section ,' nextPutAll:';nextPut:$'.
	].

codeInject:=[:source :bool  :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll: source trimSpaces ;
		crlf;
		nextPutAll:'buffer',section ,' nextPutAll:';nextPut:$'.
	].


line:=1. i:=1. lastI:=1.
i:=aTemplate findString: openTag startingAt: i.

((i - lastI)>0) ifTrue:  [
		|pos|
		pos:= (i=1) ifTrue:[1] ifFalse:[i-1].
		code nextPutAll:( aTemplate copyFrom:lastI to:(pos)).
		code nextPut:$';nextPut:$.;crlf.
	] ifFalse:[
		(i>0) ifTrue:[ code nextPut:$';crlf]].

[i >0] whileTrue:[
	c:= aTemplate at:(i + (openTag size)) .
	line:=i.
	updateLine:=  '
	line:=' , line asString, '.'.
	nextOpenTag:=openTag.
	nextCloseTag:=closeTag.
	hasTag:=true.
	i:= (i + (openTag size)).
	nonSpace:=true.
	callback:=sendEscaped.
	(c=$!!) ifTrue:[
		i:=i+1.
		callback:=nil.
		].
	(c=$=) ifTrue:[
		i:=i+1.
		closeTag:= '=' , closeTag.
		callback:=setTags.
		].
	(c=$>) ifTrue:[
		i:=i+1.
		callback:=includePartial
		].
	(c=$#) ifTrue:[
		closeTag:= closeTag.
		"we change next open tag to find the closing section tag for this section"
		"needs to skip one crlf"
		i:=i+1.
		callback:=openSection
		].
	(c=$^) ifTrue:[
		i:=i+1.
		callback:=openInvertedSection
		].
	(c=$/) ifTrue:[
		closeTag:= closeTag.
			"needs to skip one crlf"
		i:=i+1.
		callback:=closeSection
		].
	(c=${) ifTrue:[
		i:=i+1.
		closeTag:='}' , closeTag.
		callback:=sendPlain.
		].
	(c=$&) ifTrue:[
		i:=i+1.
		nonSpace:=true.
		callback:=sendPlain.
		].
	(c=$[) ifTrue:[
		i:=i+1.
		nonSpace:=true.
		closeTag:=']' , closeTag.
		callback:=codeInject.
		].
	end:=(aTemplate findString: closeTag startingAt:i).
	(end = 0) ifTrue: 
		[self error: (self debug:('Tag ', openTag, ' was not closed properly') template:aTemplate line:line file:(aJsonObjOptions at:'file'))].
	
	
	sourceCode:= (aTemplate copyFrom:i to: (end - 1)).
	
	callback 
	ifNotNil:
		[callback valueWithEnoughArguments: (Array with:sourceCode with:false with: (
			sectionStack isEmpty ifTrue:[nil]
								  ifFalse:[sectionStack top]))]
	ifNil:
		[code nextPutAll: 'buffer nextPutAll:';nextPut:$'.].
	lastI:= (end + closeTag size).
	openTag:=nextOpenTag.
	closeTag:=nextCloseTag.
	
	"only in open secction"
	(c=$#) ifTrue:[
		"we change open tag to find the closing section tag for this section"
		openTag:= openTag , '/' , sourceCode.
	].
	
	i:=aTemplate findString: openTag startingAt:lastI.
	
	((i - lastI)>=0) ifTrue:  [
			|pos|
			pos:= (i=1) ifTrue:[1] ifFalse:[i-1].
			lastI:=self skipOneCrlfOn:aTemplate at:lastI command:c.
			(callback=openSection) 
			ifTrue:[
				code nextPutAll:( Mustache clearComma: (aTemplate copyFrom:lastI to:pos)).
				code nextPut:$';crlf]
			ifFalse:[
				code nextPutAll:( aTemplate copyFrom:lastI to:pos).
				code nextPut:$';crlf.
			]
		].
	(c=$#) ifTrue:[
		"restore the real openTag"
		openTag:= nextOpenTag.
	].
	].
	
	(sectionStack size=0) ifFalse: [self error: (self debug:('Section ', ((sectionStack pop) at:'name'), ' was not closed properly') template:aTemplate line:line file:(aJsonObjOptions at:'file'))].
	lastI:=self skipOneCrlfOn:aTemplate at:lastI command:c.
	code nextPutAll: ( aTemplate copyFrom:lastI to:(aTemplate size)).
	code nextPut:$';
		nextPutAll: '.
	html ifNil:[buffer contents]
		ifNotNil:[nil].
	].'.
^code.	! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 6/18/2012 13:30'!
skipOneCrlfOn:aTemplate at:lastI command:aChar
"skips one CRLF to avoid multiple line break after clossing a section"
(aTemplate size > lastI) ifTrue:[

	(((aTemplate at: lastI )= Character cr ) and: [(aChar=$# or:[aChar=$^]) or:[aChar=$/]])
	 ifTrue:[
		|i|
		i:= lastI+1.
		((aTemplate at:i) = Character lf) ifTrue: [i:= i+1].
		^i.
		]
	].
^lastI

! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
tags
	^ tags! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:42'!
tags: anArrayOfTwoDelimiters
	tags := anArrayOfTwoDelimiters! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
version
	^ version! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
version: anObject
	version := anObject! !

Object subclass: #WAMustacheSectionTag
	instanceVariableNames: 'inverted html name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!WAMustacheSectionTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:32'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html
	^ html! !

!WAMustacheSectionTag methodsFor: 'accessing' stamp: 'JesusMari 2/5/2013 18:32'!
html: anObject
	html := anObject! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:43'!
initialize
inverted:=false! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
inverted
inverted:=true! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/5/2013 15:39'!
name:aSectionName
name:=aSectionName! !

!WAMustacheSectionTag methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/8/2013 16:57'!
with:aBlock
self html  flush.
self html document nextPutAll: (inverted ifFalse:['{{#',name,'}}'] ifTrue:['{{^',name,'}}']).
self html  flush.
aBlock value.
self html  flush.
self html document nextPutAll: '{{/',name,'}}'.! !

Object subclass: #WAMustacheTag
	instanceVariableNames: 'mustacheInstance template html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Core'!

!WAMustacheTag class methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/8/2012 12:03'!
on:html
	| i |
	i:=self new.
	i html:html.
	^i! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:33'!
basePath: aCompletePath
mustacheInstance ifNil:[mustacheInstance:=Mustache instanceFromFolder:aCompletePath]
! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 2/5/2013 18:15'!
html
^html! !

!WAMustacheTag methodsFor: 'private' stamp: 'JesusMari 12/5/2012 15:41'!
html: aCanvas
html:=aCanvas! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 3/8/2013 10:37'!
partial:aPartialName
self html flush.
self html document nextPutAll: '{{>',aPartialName,'}}'.
! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 15:38'!
section
^ WAMustacheSectionTag on:html! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 2/5/2013 18:07'!
template
^template! !

!WAMustacheTag methodsFor: 'common' stamp: 'JesusMari 12/5/2012 15:24'!
template:aTemplate
template:=aTemplate! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 15:29'!
template:aTemplate view:aView
self template:aTemplate.
self view:aView.
! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
unescapedVariable:aName

^'{{&',aName,'}}'! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/18/2013 14:14'!
variable:aName
^'{{',aName,'}}'! !

!WAMustacheTag methodsFor: 'server-side' stamp: 'JesusMari 12/5/2012 16:27'!
view: aView
(template isKindOf:String) ifTrue:[
	mustacheInstance renderTemplateAt: template view:aView on:html.
	].
(template class superclass = MustacheTemplate class)  ifTrue:[
	Mustache toHtml: template view:aView on:html.
	]! !

!WAMustacheTag methodsFor: 'client-side' stamp: 'JesusMari 2/5/2013 22:24'!
with: aBlock
self html flush.
self html document nextPutAll:'<script id="'.
self html document nextPutAll: self template.
self html document nextPutAll:'" type="text/x-jquery-tmpl">'.
aBlock value.
self html document nextPutAll:'</script>'.
self html flush.! !

!WAHtmlCanvas methodsFor: '*mustache-seaside-core' stamp: 'JesusMari 12/5/2012 15:36'!
mustache
	^ ( WAMustacheTag on:self)! !
MustacheCounter2 initialize!
MustacheCounter initialize!
